// Generated by dts-bundle v0.6.1
// Dependencies for this module:
//   ../../react

declare module 'mobxForms' {
    import Field from 'mobxForms/Field';
    import FieldArray from 'mobxForms/FieldArray';
    import FormsStore from 'mobxForms/FormsStore';
    import mobxForm from 'mobxForms/mobxForm';
    export { Field, FieldArray, FormsStore, mobxForm };
}

declare module 'mobxForms/Field' {
    import * as React from 'react';
    import { IContext } from "mobxForms/mobxForm";
    import FieldStore from 'mobxForms/containers/FieldStore';
    import { Value, SynthEvent } from 'mobxForms/utils/getValue';
    export type Validate = (value: Value) => string | null;
    export interface IProps {
        name: string;
        component: React.ComponentClass<any> | React.StatelessComponent<any> | string;
        index?: number;
        validate?: Validate;
        defaultValue?: string;
    }
    export default class Field extends React.Component<IProps, void> {
        static defaultProps: {
            validate: () => null;
            defaultValue: string;
        };
        static contextTypes: {
            mobxForms: React.Validator<any>;
        };
        context: IContext;
        position: string;
        field: FieldStore;
        constructor(props: IProps);
        componentWillMount(): void;
        componentWillUnmount(): void;
        handleChange(ev: SynthEvent): void;
        handleFocus(): void;
        handleBlur(): void;
        render(): JSX.Element;
    }
}

declare module 'mobxForms/FieldArray' {
    import * as React from 'react';
    import { IContext } from "mobxForms/mobxForm";
    import FormStore from "mobxForms/containers/FormStore";
    export interface IProps {
        name: string;
        component: React.ComponentClass<any> | React.StatelessComponent<any>;
        flat?: boolean;
        index?: number | undefined;
    }
    export interface IFields {
        map: Function;
        push: Function;
        pop: Function;
        unshift: Function;
        shift: Function;
    }
    export default class FieldArray extends React.Component<IProps, void> {
        static defaultProps: {
            flat: boolean;
        };
        static contextTypes: {
            mobxForms: React.Validator<any>;
        };
        static childContextTypes: {
            mobxForms: React.Validator<any>;
        };
        context: IContext;
        position: string;
        location: string;
        fields: IFields;
        getChildContext(): {
            mobxForms: {
                form: FormStore;
                context: string;
                flatArray: boolean | undefined;
            };
        };
        componentWillMount(): void;
        componentWillUnmount(): void;
        render(): React.ReactElement<any>;
    }
}

declare module 'mobxForms/FormsStore' {
    import FormStore from 'mobxForms/containers/FormStore';
    export interface IForms {
            [key: string]: FormStore;
    }
    export default class FormsStore {
            forms: IForms;
            /**
                * @protected
                * @param name: string - name of the form
                */
            addForm(name: string): void;
            /**
                * @protected
                * @param name: string - name of the form
                */
            removeForm(name: string): void;
    }
}

declare module 'mobxForms/mobxForm' {
    import * as React from 'react';
    import FormStore from 'mobxForms/containers/FormStore';
    import FormsStore from 'mobxForms/FormsStore';
    export interface IOptions {
        form: string;
    }
    export interface IWrappedProps {
        mobxForms: FormsStore;
    }
    export interface IContext {
        mobxForms: {
            form: FormStore;
            context: string;
            flatArray: boolean;
        };
    }
    export type WrappedComponent = React.ComponentClass<any> | React.StatelessComponent<any>;
    const mobxForm: (options: IOptions) => (Wrapped: WrappedComponent) => React.ComponentClass<any>;
    export default mobxForm;
}

declare module 'mobxForms/containers/FieldStore' {
    import { Value } from "mobxForms/utils/getValue";
    export interface IField {
        __mobxField: boolean;
    }
    export interface Input {
        value?: Value;
        error?: string | null;
    }
    export interface IFieldProps {
        value: Value;
        visited: boolean;
        touched: boolean;
        active: boolean;
        error: string | null;
        dirty: boolean;
    }
    export default class FieldStore implements IField {
        __mobxField: boolean;
        value: Value;
        error: string | null;
        visited: boolean;
        touched: boolean;
        active: boolean;
        dirty: boolean;
        constructor(input?: Input);
        readonly props: IFieldProps;
    }
}

declare module 'mobxForms/utils/getValue' {
    import * as React from 'react';
    export type Target = HTMLInputElement | HTMLSelectElement;
    export type SynthEvent = React.SyntheticEvent<Target>;
    export type Value = string | string[] | number | boolean | FileList | null;
    const getValue: (ev: any) => Value;
    export default getValue;
}

declare module 'mobxForms/containers/FormStore' {
    import { IMappedWrap } from 'mobxForms/utils/mapForm';
    import FieldStore from 'mobxForms/containers/FieldStore';
    import { FormObject } from 'mobxForms/types/Form';
    export default class FormStore {
        fields: FormObject;
        readonly values: IMappedWrap<string>;
        readonly errors: IMappedWrap<string | null>;
        readonly valid: boolean;
        addField(context: string, name: string, field: FieldStore): void;
        addFieldIndex(context: string, name: number, field: FieldStore): void;
        addFieldArray(context: string, name: string): void;
        removeField(context: string, name: string): void;
        removeFieldIndex(context: string, index: number): void;
        map<T>(context: string, fn: (x: number) => T): Array<T>;
        push(context: string): void;
        pop(context: string): void;
        unshift(context: string): void;
        shift(context: string): void;
    }
}

declare module 'mobxForms/utils/mapForm' {
    import { IField } from "mobxForms/containers/FieldStore";
    export type ArrayUnit<T> = T | T[] | IArrays<T>;
    export interface IArrays<T> extends Array<ArrayUnit<T>> {
        [key: number]: ArrayUnit<T>;
    }
    export type Mapped<T> = T | IMappedWrap<T>;
    export type IMappedWrap<T> = IMappedObject<T> | IMappedArray<T>;
    export interface IMappedArray<T> extends Array<Mapped<T>> {
        [key: number]: Mapped<T>;
    }
    export interface IMappedObject<T> {
        [key: string]: Mapped<T>;
    }
    export const mapDeep: <T>(fn: (f: IField) => T, form: IMappedWrap<IField>) => IMappedWrap<T>;
    export const mapFlat: <T>(fn: (f: IField) => T, form: IMappedObject<IField>) => T[];
}

declare module 'mobxForms/types/Form' {
    import FieldStore from 'mobxForms/containers/FieldStore';
    export type FormObject = {
        [key: string]: FieldStore | FormArray;
    };
    export type FormArray = FieldStore[] | FormObject[];
    export type FormElement = FormObject | FormArray;
}

