/// <reference types="react" />
import * as React from 'react';
import { IContext } from "./mobxForm";
import FieldStore from './containers/FieldStore';
import { Value, SynthEvent } from './utils/getValue';
export declare type Validate = (value: Value) => string | null;
export interface IProps {
    name: string;
    component: React.ComponentClass<any> | React.StatelessComponent<any> | string;
    index?: number;
    validate?: Validate;
    defaultValue?: string;
}
export default class Field extends React.Component<IProps, void> {
    static defaultProps: {
        validate: () => null;
        defaultValue: string;
    };
    static contextTypes: {
        mobxForms: React.Validator<any>;
    };
    context: IContext;
    position: string;
    field: FieldStore;
    constructor(props: IProps);
    componentWillMount(): void;
    componentWillUnmount(): void;
    handleChange(ev: SynthEvent): void;
    handleFocus(): void;
    handleBlur(): void;
    render(): JSX.Element;
}
