"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var __decorate = undefined && undefined.__decorate || function (decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if ((typeof Reflect === "undefined" ? "undefined" : _typeof(Reflect)) === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);else for (var i = decorators.length - 1; i >= 0; i--) {
        if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    }return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var React = require('react');
var mobx_react_1 = require('mobx-react');
var R = require('ramda');
var invariant = require('invariant');
var FormStore_1 = require("./containers/FormStore");
var FieldStore_1 = require('./containers/FieldStore');
var prepareProps_1 = require('./utils/prepareProps');
var getValue_1 = require('./utils/getValue');
var Field = function (_React$Component) {
    _inherits(Field, _React$Component);

    function Field(props) {
        _classCallCheck(this, Field);

        var _this = _possibleConstructorReturn(this, (Field.__proto__ || Object.getPrototypeOf(Field)).call(this, props));

        _this.handleChange = _this.handleChange.bind(_this);
        _this.handleFocus = _this.handleFocus.bind(_this);
        _this.handleBlur = _this.handleBlur.bind(_this);
        return _this;
    }

    _createClass(Field, [{
        key: "componentWillMount",
        value: function componentWillMount() {
            var _props = this.props;
            var name = _props.name;
            var index = _props.index;
            var defaultValue = _props.defaultValue;
            var validate = _props.validate;

            invariant(this.context.mobxForms, '[mobx-forms] Field must be in a component decorated with "mobxForm"');
            var _context$mobxForms = this.context.mobxForms;
            var form = _context$mobxForms.form;
            var context = _context$mobxForms.context;
            var flatArray = _context$mobxForms.flatArray;

            if (context === '') {
                invariant(typeof index !== 'number', '[mobx-forms] "index" can only be passed to components inside ArrayField');
            } else {
                invariant(typeof index === 'number', '[mobx-forms] "index" must be passed to ArrayField components');
            }
            this.position = !flatArray && typeof index === 'number' ? context + "#" + index : context;
            this.field = new FieldStore_1.default({
                value: defaultValue,
                error: validate(defaultValue)
            });
            if (flatArray && typeof index === 'number') {
                form.addFieldIndex(this.position, index, this.field);
            } else {
                form.addField(this.position, name, this.field);
            }
        }
    }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
            var _props2 = this.props;
            var index = _props2.index;
            var name = _props2.name;
            var _context$mobxForms2 = this.context.mobxForms;
            var form = _context$mobxForms2.form;
            var flatArray = _context$mobxForms2.flatArray;

            if (flatArray && typeof index === 'number') {
                form.removeFieldIndex(this.position, index);
            } else {
                form.removeField(this.position, name);
            }
        }
    }, {
        key: "handleChange",
        value: function handleChange(ev) {
            var _props3 = this.props;
            var validate = _props3.validate;
            var defaultValue = _props3.defaultValue;

            var value = getValue_1.default(ev);
            this.field.value = value;
            this.field.error = validate(value);
            this.field.dirty = value !== defaultValue;
        }
    }, {
        key: "handleFocus",
        value: function handleFocus() {
            this.field.active = true;
            this.field.visited = true;
        }
    }, {
        key: "handleBlur",
        value: function handleBlur() {
            this.field.active = false;
            this.field.touched = true;
        }
    }, {
        key: "render",
        value: function render() {
            var component = this.props.component;

            var props = R.merge({
                onChange: this.handleChange,
                onFocus: this.handleFocus,
                onBlur: this.handleBlur
            }, R.omit(['component'], this.props));

            var _prepareProps_1$defau = prepareProps_1.default(R.merge(props, this.field.props));

            var input = _prepareProps_1$defau.input;
            var meta = _prepareProps_1$defau.meta;
            var custom = _prepareProps_1$defau.custom;

            if (typeof component === 'string') {
                return React.createElement(component, R.merge(custom, input));
            }
            return React.createElement(component, R.merge(custom, { input: input, meta: meta }));
        }
    }]);

    return Field;
}(React.Component);
Field.defaultProps = {
    validate: function validate() {
        return null;
    },
    defaultValue: ''
};
Field.contextTypes = {
    mobxForms: React.PropTypes.shape({
        form: React.PropTypes.instanceOf(FormStore_1.default).isRequired,
        context: React.PropTypes.string.isRequired,
        flatArray: React.PropTypes.bool.isRequired
    }).isRequired
};
Field = __decorate([mobx_react_1.observer], Field);
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Field;