/// <reference types="react" />
import * as React from 'react';
import { IContext } from "./mobxForm";
import FormStore from "./containers/FormStore";
export interface IProps {
    name: string;
    component: React.ComponentClass<any> | React.StatelessComponent<any>;
    flat?: boolean;
    index?: number | undefined;
}
export interface IFields {
    map: Function;
    push: Function;
    pop: Function;
    unshift: Function;
    shift: Function;
}
export default class FieldArray extends React.Component<IProps, void> {
    static defaultProps: {
        flat: boolean;
    };
    static contextTypes: {
        mobxForms: React.Validator<any>;
    };
    static childContextTypes: {
        mobxForms: React.Validator<any>;
    };
    context: IContext;
    position: string;
    location: string;
    fields: IFields;
    getChildContext(): {
        mobxForms: {
            form: FormStore;
            context: string;
            flatArray: boolean | undefined;
        };
    };
    componentWillMount(): void;
    componentWillUnmount(): void;
    render(): React.ReactElement<any>;
}
