"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var __decorate = undefined && undefined.__decorate || function (decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if ((typeof Reflect === "undefined" ? "undefined" : _typeof(Reflect)) === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);else for (var i = decorators.length - 1; i >= 0; i--) {
        if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    }return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var React = require('react');
var mobx_react_1 = require('mobx-react');
var R = require('ramda');
var invariant = require('invariant');
var FormStore_1 = require("./containers/FormStore");
var consts_1 = require('./utils/consts');
var contextShape = {
    form: React.PropTypes.instanceOf(FormStore_1.default).isRequired,
    context: React.PropTypes.string.isRequired,
    flatArray: React.PropTypes.bool.isRequired
};
var FieldArray = function (_React$Component) {
    _inherits(FieldArray, _React$Component);

    function FieldArray() {
        _classCallCheck(this, FieldArray);

        return _possibleConstructorReturn(this, (FieldArray.__proto__ || Object.getPrototypeOf(FieldArray)).apply(this, arguments));
    }

    _createClass(FieldArray, [{
        key: "getChildContext",
        value: function getChildContext() {
            var _props = this.props;
            var name = _props.name;
            var index = _props.index;
            var flat = _props.flat;
            var _context$mobxForms = this.context.mobxForms;
            var form = _context$mobxForms.form;
            var context = _context$mobxForms.context;

            return {
                mobxForms: {
                    form: form,
                    context: typeof index === 'number' ? context + "#" + index + "." + name : name,
                    flatArray: flat
                }
            };
        }
    }, {
        key: "componentWillMount",
        value: function componentWillMount() {
            var _this2 = this;

            var _props2 = this.props;
            var name = _props2.name;
            var index = _props2.index;

            invariant(this.context.mobxForms, '[mobx-forms] FieldArray must be in a component decorated with "mobxForm"');
            var _context$mobxForms2 = this.context.mobxForms;
            var form = _context$mobxForms2.form;
            var context = _context$mobxForms2.context;
            var flatArray = _context$mobxForms2.flatArray;

            var validIndex = typeof index === 'number';
            if (context === '') {
                invariant(!validIndex, '[mobx-forms] "index" can only be passed to components inside ArrayField');
            } else {
                invariant(validIndex, '[mobx-forms] "index" must be passed to ArrayField components');
            }
            this.position = validIndex ? context + "#" + index : '';
            this.location = validIndex ? context + "#" + index + "." + name : name;
            this.fields = {
                map: function map(fn) {
                    return form.map(_this2.location, fn);
                },
                push: function push() {
                    return form.push(_this2.location);
                },
                pop: function pop() {
                    return form.pop(_this2.location);
                },
                unshift: function unshift() {
                    return form.unshift(_this2.location);
                },
                shift: function shift() {
                    return form.shift(_this2.location);
                }
            };
            invariant(!flatArray, '[mobx-forms] FieldArray cannot be located within a flat FieldArray');
            form.addFieldArray(this.position, name);
        }
    }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
            var name = this.props.name;
            var form = this.context.mobxForms.form;

            form.removeField(this.position, name);
        }
    }, {
        key: "render",
        value: function render() {
            var component = this.props.component;

            var rest = R.omit(consts_1.ARRAY_IGNORE_PROPS, this.props);
            return React.createElement(component, R.merge(rest, {
                fields: this.fields
            }));
        }
    }]);

    return FieldArray;
}(React.Component);
FieldArray.defaultProps = {
    flat: false
};
FieldArray.contextTypes = {
    mobxForms: React.PropTypes.shape(contextShape).isRequired
};
FieldArray.childContextTypes = {
    mobxForms: React.PropTypes.shape(contextShape).isRequired
};
FieldArray = __decorate([mobx_react_1.observer], FieldArray);
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = FieldArray;