import { IMappedWrap } from '../utils/mapForm';
import FieldStore from './FieldStore';
import { FormObject } from '../types/Form';
export default class FormStore {
    fields: FormObject;
    readonly values: IMappedWrap<string>;
    readonly errors: IMappedWrap<string | null>;
    readonly valid: boolean;
    addField(context: string, name: string, field: FieldStore): void;
    addFieldIndex(context: string, name: number, field: FieldStore): void;
    addFieldArray(context: string, name: string): void;
    removeField(context: string, name: string): void;
    removeFieldIndex(context: string, index: number): void;
    map<T>(context: string, fn: (x: number) => T): Array<T>;
    push(context: string): void;
    pop(context: string): void;
    unshift(context: string): void;
    shift(context: string): void;
}
