"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var __decorate = undefined && undefined.__decorate || function (decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if ((typeof Reflect === "undefined" ? "undefined" : _typeof(Reflect)) === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);else for (var i = decorators.length - 1; i >= 0; i--) {
        if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    }return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var mobx = require('mobx');
var invariant = require('invariant');
var R = require('ramda');
var traverse_1 = require('../utils/traverse');
var mapForm_1 = require('../utils/mapForm');

var FormStore = function () {
    function FormStore() {
        _classCallCheck(this, FormStore);

        this.fields = {};
    }

    _createClass(FormStore, [{
        key: "addField",
        value: function addField(context, name, field) {
            var base = traverse_1.default(this.fields, context);
            if (mobx.isObservableObject(base)) {
                var baseObj = base;
                invariant(!baseObj[name], "[mobx-forms] Tried to mount a Field '" + name + "' twice. Names must be unique!");
                baseObj[name] = field;
            }
        }
    }, {
        key: "addFieldIndex",
        value: function addFieldIndex(context, name, field) {
            var base = traverse_1.default(this.fields, context);
            if (mobx.isObservableArray(base)) {
                base[name] = field;
            }
        }
    }, {
        key: "addFieldArray",
        value: function addFieldArray(context, name) {
            var base = traverse_1.default(this.fields, context);
            if (mobx.isObservableObject(base)) {
                var baseObj = base;
                invariant(!baseObj[name], "[mobx-forms] Tried to mount a FieldArray '" + name + "' twice. Names must be unique!");
                baseObj[name] = mobx.observable([]);
            }
        }
    }, {
        key: "removeField",
        value: function removeField(context, name) {
            var base = traverse_1.default(this.fields, context);
            if (mobx.isObservableObject(base)) {
                delete base[name];
            }
        }
    }, {
        key: "removeFieldIndex",
        value: function removeFieldIndex(context, index) {
            var base = traverse_1.default(this.fields, context);
            if (mobx.isObservableArray(base)) {
                base.splice(index, 1);
            }
        }
        // Array functions
        // ---

    }, {
        key: "map",
        value: function map(context, fn) {
            var base = traverse_1.default(this.fields, context);
            if (mobx.isObservableArray(base)) {
                return R.map(fn, R.addIndex(R.map)(function (_, i) {
                    return i;
                }, base));
            }
            return [];
        }
    }, {
        key: "push",
        value: function push(context) {
            var base = traverse_1.default(this.fields, context);
            if (mobx.isObservableArray(base)) {
                base.push(mobx.observable({}));
            }
        }
    }, {
        key: "pop",
        value: function pop(context) {
            var base = traverse_1.default(this.fields, context);
            if (mobx.isObservableArray(base)) {
                base.pop();
            }
        }
    }, {
        key: "unshift",
        value: function unshift(context) {
            var base = traverse_1.default(this.fields, context);
            if (mobx.isObservableArray(base)) {
                base.unshift(mobx.observable({}));
            }
        }
    }, {
        key: "shift",
        value: function shift(context) {
            var base = traverse_1.default(this.fields, context);
            if (mobx.isObservableArray(base)) {
                base.shift();
            }
        }
    }, {
        key: "values",
        get: function get() {
            return mapForm_1.mapDeep(R.prop('value'), mobx.toJS(this.fields));
        }
    }, {
        key: "errors",
        get: function get() {
            return mapForm_1.mapDeep(R.prop('error'), mobx.toJS(this.fields));
        }
    }, {
        key: "valid",
        get: function get() {
            return R.all(R.equals(null), mapForm_1.mapFlat(R.prop('error'), mobx.toJS(this.fields)));
        }
    }]);

    return FormStore;
}();

__decorate([mobx.observable], FormStore.prototype, "fields", void 0);
__decorate([mobx.computed], FormStore.prototype, "values", null);
__decorate([mobx.computed], FormStore.prototype, "errors", null);
__decorate([mobx.computed], FormStore.prototype, "valid", null);
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = FormStore;