"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var React = require('react');
var mobx_react_1 = require('mobx-react');
var invariant = require('invariant');
var R = require('ramda');
var FormStore_1 = require('./containers/FormStore');
var getName = function getName(Wrapped) {
    return Wrapped.displayName || Wrapped.name || 'Component';
};
var mobxForm = function mobxForm(options) {
    invariant(options.form && typeof options.form === 'string', '[mobx-forms] "form" is a required string on the "mobxForm" decorator.');
    return function (Wrapped) {
        var MobxForm = function (_React$Component) {
            _inherits(MobxForm, _React$Component);

            function MobxForm() {
                _classCallCheck(this, MobxForm);

                return _possibleConstructorReturn(this, (MobxForm.__proto__ || Object.getPrototypeOf(MobxForm)).apply(this, arguments));
            }

            _createClass(MobxForm, [{
                key: 'getChildContext',
                value: function getChildContext() {
                    return {
                        mobxForms: {
                            form: this.props.mobxForms.forms[options.form],
                            context: '',
                            flatArray: false
                        }
                    };
                }
            }, {
                key: 'componentWillMount',
                value: function componentWillMount() {
                    this.props.mobxForms.addForm(options.form);
                }
            }, {
                key: 'componentWillUnmount',
                value: function componentWillUnmount() {
                    this.props.mobxForms.removeForm(options.form);
                }
            }, {
                key: 'render',
                value: function render() {
                    var props = R.omit(['mobxForms'], this.props);
                    return React.createElement(Wrapped, R.merge(props, {
                        form: this.props.mobxForms.forms[options.form]
                    }));
                }
            }]);

            return MobxForm;
        }(React.Component);

        MobxForm.childContextTypes = {
            mobxForms: React.PropTypes.shape({
                form: React.PropTypes.instanceOf(FormStore_1.default).isRequired,
                context: React.PropTypes.string.isRequired,
                flatArray: React.PropTypes.bool.isRequired
            }).isRequired
        };
        var Injected = mobx_react_1.inject('mobxForms')(MobxForm);
        Injected.displayName = 'MobxForm(' + getName(Wrapped) + ')';
        return Injected;
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = mobxForm;