"use strict";

var isEvent = function isEvent(thing) {
    return Boolean(thing && thing.preventDefault && thing.stopPropagation);
};
var getSelectedValues = function getSelectedValues(options) {
    return Array.from(options).filter(function (option) {
        return option.selected;
    }).map(function (option) {
        return option.value;
    });
};
var getValue = function getValue(ev) {
    if (!isEvent(ev)) {
        return ev;
    }
    var target = ev.target;
    switch (target.type) {
        case 'checkbox':
            return target.checked;
        case 'file':
            return target.files;
        case 'select-multiple':
            return getSelectedValues(target.options);
        case 'range':
        case 'number':
            return Number(target.value);
        default:
            return target.value;
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = getValue;