import { IField } from "../containers/FieldStore";
export declare type ArrayUnit<T> = T | T[] | IArrays<T>;
export interface IArrays<T> extends Array<ArrayUnit<T>> {
    [key: number]: ArrayUnit<T>;
}
export declare type Mapped<T> = T | IMappedWrap<T>;
export declare type IMappedWrap<T> = IMappedObject<T> | IMappedArray<T>;
export interface IMappedArray<T> extends Array<Mapped<T>> {
    [key: number]: Mapped<T>;
}
export interface IMappedObject<T> {
    [key: string]: Mapped<T>;
}
export declare const mapDeep: <T>(fn: (f: IField) => T, form: IMappedWrap<IField>) => IMappedWrap<T>;
export declare const mapFlat: <T>(fn: (f: IField) => T, form: IMappedObject<IField>) => T[];
