"use strict";

var R = require('ramda');
var isField = function isField(thing) {
    return R.has('__mobxField', thing);
};
exports.mapDeep = function (fn, form) {
    return R.map(function (val) {
        if (isField(val)) {
            return fn(val);
        }
        return exports.mapDeep(fn, val);
    }, form);
}; // see TODO above
var toArrays = function toArrays(form) {
    return R.map(function (val) {
        if (isField(val)) {
            return val;
        }
        return toArrays(R.values(val));
    }, form);
};
exports.mapFlat = function (fn, form) {
    return R.compose(R.map(fn), R.flatten, toArrays, R.values)(form);
};