"use strict";

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var R = require('ramda');
function maybeHash(form, path) {
    var _path$split = path.split('#');

    var _path$split2 = _slicedToArray(_path$split, 2);

    var name = _path$split2[0];
    var index = _path$split2[1];

    return index ? R.path([name, index], form) : R.prop(name, form);
}
function traverse(form, context) {
    if (context === '') {
        return form;
    }
    var path = context.split('.');
    var head = R.head(path);
    var tail = R.tail(path);
    var fields = maybeHash(form, head);
    if (!fields) {
        return null;
    }
    if (tail.length > 0) {
        return traverse(fields, tail.join('.'));
    }
    return fields;
}
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = traverse;